@echo off

if "%~1"=="" GOTO usage

call vars.bat

cd %HOME%
set KEY_CN=%~1
gmkseed -q
mkkey -t PKCS11 -k "%~1"
openssl req -batch -utf8 -nodes -new -engine cryptocom -keyform ENGINE -key "PKCS11:%~2" -out "%KEY_DIR%\%~1.csr" -config %KEY_CONFIG%
openssl ca -batch -days 455 -out "%KEY_DIR%\%~1.crt" -in "%KEY_DIR%\%~1.csr" -extensions tlsclient -preserveDN -config %KEY_CONFIG%
if exist %KEY_DIR%\cross-ca.crt (
	type %KEY_DIR%\cross-ca.crt >> "%KEY_DIR%\%~1.crt"
)

goto end

:usage
echo usage: %0 user_common_name


:end
